import hashlib
import itertools
from concurrent.futures import ProcessPoolExecutor, as_completed
from tqdm import tqdm
import argparse
print("@十七大王的MD5暴力破解py，更适合tg中国版的小宝宝体质")
print("请加入频道及时获取最新py以及思路：https://t.me/shiqidexiaowo")
#请支持十七大王的统治！！！
#十七大王的频道：https://t.me/shiqidexiaowo
#多多支持十七大王，谢谢各位宝宝！
#另外频道每天更新各种py和思路已经点号思路教程wwg
#请多多关照！
#转发带频道啊：
#https://t.me/shiqidexiaowo
#https://t.me/shiqidexiaowo
#https://t.me/shiqidexiaowo
#https://t.me/shiqidexiaowo

class MD5CrackerPro:
    def __init__(self):
        self.top_passwords = [
            '123456', 'password', '123456789', 'qwerty', 
            '111111', 'admin', '12345678', 'abc123'
        ]  # 预加载Top100万中的前8个高频密码[2,8](@ref)
    
    @staticmethod
    def is_valid_md5(hash_str):
        return len(hash_str) in (32, 16) and all(c in string.hexdigits for c in hash_str)

    def _priority_check(self, target_hash):
        for pwd in tqdm(self.top_passwords, desc="高频密码检测"):
            if hashlib.md5(pwd.encode()).hexdigest() == target_hash:
                return pwd
        
        for base in self.top_passwords:
            for variant in [base, base.capitalize()]:
                for i in range(100):
                    guess = f"{variant}{i}"
                    if hashlib.md5(guess.encode()).hexdigest() == target_hash:
                        return guess
        return None

    def _brute_force(self, target_hash, max_length=8, workers=4):
        charset = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%'
        total = sum(len(charset)**n for n in range(1, max_length+1))
        
        with tqdm(total=total, desc="暴力破解进度") as pbar:
            with ProcessPoolExecutor(max_workers=workers) as executor:
                futures = {}
                for length in range(1, max_length+1):
                    for batch in self._batch_generator(charset, length, batch_size=10000):
                        future = executor.submit(self._check_batch, batch, target_hash)
                        futures[future] = batch
                
                for future in as_completed(futures):
                    if result := future.result():
                        executor.shutdown(wait=False)
                        return result
                    pbar.update(len(futures[future]))
        return None

    def _batch_generator(self, charset, length, batch_size=10000):
        product = itertools.product(charset, repeat=length)
        while True:
            batch = list(islice(product, batch_size))
            if not batch:
                break
            yield [''.join(p) for p in batch]

    @staticmethod
    def _check_batch(guesses, target_hash):
        for guess in guesses:
            if hashlib.md5(guess.encode()).hexdigest() == target_hash:
                return guess
        return None

    def crack(self, target_hash, dict_path=None):
        if not self.is_valid_md5(target_hash):
            raise ValueError("无效的MD5哈希值")
        
        target_hash = target_hash.lower()
        if result := self._priority_check(target_hash):
            return result
            
        if dict_path:
            try:
                with open(dict_path, 'r', encoding='utf-8') as f:
                    for line in tqdm(f, desc="📖字典文件扫描"):
                        line = line.strip()
                        if hashlib.md5(line.encode()).hexdigest() == target_hash:
                            return line
            except FileNotFoundError:
                print("⚠️ 字典文件未找到，启用多进程暴力破解")

        return self._brute_force(target_hash, max_length=8, workers=8)

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="极速MD5破解工具")
    parser.add_argument('hash', help="需要破解的MD5哈希值")
    parser.add_argument('-d', '--dict', help="可选字典文件路径")
    args = parser.parse_args()

    cracker = MD5CrackerPro()
    if result := cracker.crack(args.hash, args.dict):
        print(f"✅ 破解成功！明文为: \033[1;32m{result}\033[0m")
    else:
        print("❌ 破解失败，建议：")
        print("1. 使用更大密码长度参数（默认最大8位）")
        print("2. 准备Top100万密码字典（成功率提升60%+）")
#请支持十七大王的统治！！！
#十七大王的频道：https://t.me/shiqidexiaowo
#多多支持十七大王，谢谢各位宝宝！
#另外频道每天更新各种py和思路已经点号思路教程wwg
#请多多关照！
#转发带频道啊：
#https://t.me/shiqidexiaowo
#https://t.me/shiqidexiaowo
#https://t.me/shiqidexiaowo
#https://t.me/shiqidexiaowo
